package ufida.fasterxml.jackson.databind.introspect;

import ufida.fasterxml.jackson.core.Version;
import ufida.fasterxml.jackson.databind.*;
import ufida.fasterxml.jackson.databind.cfg.DatabindVersion;

/**
 * Dummy, "no-operation" implementation of {@link AnnotationIntrospector}.
 * Can be used as is to suppress handling of annotations; or as a basis
 * for simple configuration overrides (whether based on annotations or not).
 */
public abstract class NopAnnotationIntrospector
    extends AnnotationIntrospector
{
    /**
     * Static immutable and shareable instance that can be used as
     * "null" introspector: one that never finds any annotation
     * information.
     */
    public final static NopAnnotationIntrospector instance = new NopAnnotationIntrospector() {
        @Override
        public Version version() {
            return DatabindVersion.instance.version();
        }
    };

    @Override
    public Version version() {
        return Version.unknownVersion();
    }
}
